---------------------------------------------------------------------------
-- This VHDL file was developed by Daniel Llamocca (2013).  It may be
-- freely copied and/or distributed at no cost.  Any persons using this
-- file for any purpose do so at their own risk, and are responsible for
-- the results of such use.  Daniel Llamocca does not guarantee that
-- this file is complete, correct, or fit for any particular purpose.
-- NO WARRANTY OF ANY KIND IS EXPRESSED OR IMPLIED.  This notice must
-- accompany any copy of this file.
--------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
  
ENTITY tb_my_seq_detect IS
END tb_my_seq_detect;
 
ARCHITECTURE behavior OF tb_my_seq_detect IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT my_seq_detect
    PORT(
         clock : IN  std_logic;
         resetn : IN  std_logic;
         x : IN  std_logic;
         z : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clock : std_logic := '0';
   signal resetn : std_logic := '0';
   signal x : std_logic := '0';

 	--Outputs
   signal z : std_logic;

   -- Clock period definitions
   constant T : time := 20 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: my_seq_detect PORT MAP (
          clock => clock,
          resetn => resetn,
          x => x,
          z => z
        );

   -- Clock process definitions
   clock_process :process
   begin
		clock <= '0';
		wait for T/2;
		clock <= '1';
		wait for T/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;

      -- insert stimulus here 
		resetn <= '0'; wait for T*10;
		resetn <= '1'; wait for T*2;
		x <= '0'; wait for T;
		x <= '1'; wait for T;
		x <= '1'; wait for T;
		x <= '1'; wait for T;
		x <= '0'; wait for T;
		x <= '0'; wait for T;
		x <= '1'; wait for T;
		x <= '1'; wait for T;
		x <= '0'; wait for T;
		x <= '1'; wait for T;
		x <= '0'; wait for T;
		x <= '0'; wait for T;
		x <= '1'; wait for T;
		x <= '1'; wait for T;
		x <= '1'; wait for T;
		x <= '0'; wait for T;
		x <= '1'; wait for T;
		x <= '1'; wait for T;
		x <= '0'; wait for T;
		x <= '1'; wait for T;
		x <= '0'; wait for T;
		x <= '0'; resetn <= '0';
      wait;
   end process;

END;
